import styled from "styled-components";

import React from "react";
import { sideInfo } from "../../../sider";
import { Lenke } from "./Lenke";
import { TekstpilTilbake } from "../../Ikon/TekstpilTilbake";
import { useSetAtom } from "jotai";
import { popupInfoAtom } from "../../../kartSide/jotai/karvalgAtoms";

export const TilbakeLenke = () => {
    const setPopup = useSetAtom(popupInfoAtom);
    return (
        <StyledLenke
            onClick={() => setPopup(undefined)}
            href={sideInfo.driftsportal.href}
            størrelse="M"
        >
            <TekstpilTilbake />
            Tilbake
        </StyledLenke>
    );
};

const StyledLenke = styled(Lenke)`
    margin-left: 0.5rem;
    display: flex;
    align-items: center;
    flex-wrap: nowrap;

    svg {
        margin-right: 0.5rem;
    }
`;
