import { FriksjonsmålingMetadata } from "./friksjonsmålingTyper";
import {
    Container,
    Kategori,
    KategoriTabell,
    Opplysning,
    VisSkjulKnapp,
} from "../øktdetaljerSide/metadata/Metadata";
import styled from "styled-components";
import { useState } from "react";
import { tilNorskTimestamp } from "../utils/tid";

export interface friksjonsmålingMetadataPanelProps {
    friksjonsdataMetadata?: FriksjonsmålingMetadata;
}

export const FriksjonsmLingMetadataPanel = ({
    friksjonsdataMetadata,
}: friksjonsmålingMetadataPanelProps) => {
    const [seAllMetadata, setSeAllMetadata] = useState<boolean>(false);

    return (
        <>
            {seAllMetadata ? (
                <StyledContainer>
                    <Wrapper>
                        <KategoriTabellBred>Dato: </KategoriTabellBred>
                        <Opplysning>
                            {friksjonsdataMetadata?.dato &&
                                tilNorskTimestamp(friksjonsdataMetadata.dato)}
                        </Opplysning>
                    </Wrapper>
                    <Wrapper>
                        <KategoriTabellBred>ViaFriction: </KategoriTabellBred>
                        <Opplysning>{friksjonsdataMetadata?.viaFriction}</Opplysning>
                    </Wrapper>
                    <Wrapper>
                        <KategoriTabellBred>Enheter: </KategoriTabellBred>
                        <Opplysning>{friksjonsdataMetadata?.enheter}</Opplysning>
                    </Wrapper>
                    <Wrapper>
                        <KategoriTabellBred>Filnavn: </KategoriTabellBred>
                        <Opplysning>{friksjonsdataMetadata?.filnavn}</Opplysning>
                    </Wrapper>
                    <Wrapper>
                        <KategoriTabellBred>Programvareversjon: </KategoriTabellBred>
                        <Opplysning>{friksjonsdataMetadata?.programvareversjon}</Opplysning>
                    </Wrapper>
                    <Wrapper>
                        <KategoriTabellBred>Sted: </KategoriTabellBred>
                        <Opplysning>{friksjonsdataMetadata?.sted}</Opplysning>
                    </Wrapper>
                    <Wrapper>
                        <KategoriTabellBred>Opratør: </KategoriTabellBred>
                        <Opplysning>{friksjonsdataMetadata?.opratør}</Opplysning>
                    </Wrapper>
                    <Wrapper>
                        <KategoriTabellBred>Vær: </KategoriTabellBred>
                        <Opplysning>{friksjonsdataMetadata?.vær}</Opplysning>
                    </Wrapper>
                    <Wrapper>
                        <KategoriTabellBred>Målingskommentar: </KategoriTabellBred>
                        <Opplysning>{friksjonsdataMetadata?.målingskommentarer}</Opplysning>
                    </Wrapper>
                    <Wrapper>
                        <KategoriTabellBred>mwKaliberingV: </KategoriTabellBred>
                        <Opplysning>{friksjonsdataMetadata?.mwKalibreringV}</Opplysning>
                    </Wrapper>
                    <Wrapper>
                        <KategoriTabellBred>mwKaliberingH: </KategoriTabellBred>
                        <Opplysning>{friksjonsdataMetadata?.mwKalibreringH}</Opplysning>
                    </Wrapper>
                    <Wrapper>
                        <KategoriTabellBred>twKalibering: </KategoriTabellBred>
                        <Opplysning>{friksjonsdataMetadata?.twKalibrering}</Opplysning>
                    </Wrapper>
                    <Wrapper>
                        <KategoriTabellBred>KaliberingV: </KategoriTabellBred>
                        <Opplysning>
                            {friksjonsdataMetadata?.kalibreringV &&
                                `A: ${friksjonsdataMetadata?.kalibreringV.A}, B: ${friksjonsdataMetadata?.kalibreringV.B}, C: ${friksjonsdataMetadata?.kalibreringV.C}`}
                        </Opplysning>
                    </Wrapper>
                    <Wrapper>
                        <KategoriTabellBred>KaliberingH: </KategoriTabellBred>
                        <Opplysning>
                            {friksjonsdataMetadata?.kalibreringH &&
                                `A: ${friksjonsdataMetadata?.kalibreringH.A}, B: ${friksjonsdataMetadata?.kalibreringH.B}, C: ${friksjonsdataMetadata?.kalibreringH.C}`}
                        </Opplysning>
                    </Wrapper>
                    <Wrapper>
                        <KategoriTabellBred>Vannfilm: </KategoriTabellBred>
                        <Opplysning>{friksjonsdataMetadata?.vannfilm}</Opplysning>
                    </Wrapper>
                    <Wrapper>
                        <KategoriTabellBred>Spor: </KategoriTabellBred>
                        <Opplysning>{friksjonsdataMetadata?.spor}</Opplysning>
                    </Wrapper>
                    <Wrapper>
                        <KategoriTabellBred>Utsyr: </KategoriTabellBred>
                        <Opplysning>{friksjonsdataMetadata?.utstyr}</Opplysning>
                    </Wrapper>
                    <Wrapper>
                        <KategoriTabellBred>Utstyrmarknader: </KategoriTabellBred>
                        <Opplysning>{friksjonsdataMetadata?.utstyrsmerknader}</Opplysning>
                    </Wrapper>
                    <Wrapper>
                        <KategoriTabellBred>Bilnummer: </KategoriTabellBred>
                        <Opplysning>{friksjonsdataMetadata?.bilnummer}</Opplysning>
                    </Wrapper>
                    <Wrapper>
                        <KategoriTabellBred>Vegnettsreverversjon: </KategoriTabellBred>
                        <Opplysning>{friksjonsdataMetadata?.vegnettserverversjon}</Opplysning>
                    </Wrapper>
                    <Wrapper>
                        <KategoriTabellBred>Vegnettsversjon: </KategoriTabellBred>
                        <Opplysning>{friksjonsdataMetadata?.vegnettsversjon}</Opplysning>
                    </Wrapper>
                    <Wrapper>
                        <KategoriTabellBred>Fylke: </KategoriTabellBred>
                        <Opplysning>{friksjonsdataMetadata?.fylke}</Opplysning>
                    </Wrapper>
                    <Wrapper>
                        <KategoriTabellBred>Veg: </KategoriTabellBred>
                        <Opplysning>{friksjonsdataMetadata?.vei}</Opplysning>
                    </Wrapper>
                    <Wrapper>
                        <KategoriTabellBred>Retning: </KategoriTabellBred>
                        <Opplysning>{friksjonsdataMetadata?.retning}</Opplysning>
                    </Wrapper>
                    <Wrapper>
                        <KategoriTabellBred>Fil: </KategoriTabellBred>
                        <Opplysning>{friksjonsdataMetadata?.fil}</Opplysning>
                    </Wrapper>
                    <Wrapper>
                        <KategoriTabellBred>StartHp: </KategoriTabellBred>
                        <Opplysning>{friksjonsdataMetadata?.startHp}</Opplysning>
                    </Wrapper>
                    <Wrapper>
                        <KategoriTabellBred>Start: </KategoriTabellBred>
                        <Opplysning>{friksjonsdataMetadata?.start}</Opplysning>
                    </Wrapper>
                    <Wrapper>
                        <KategoriTabellBred>Type: </KategoriTabellBred>
                        <Opplysning>{friksjonsdataMetadata?.type}</Opplysning>
                    </Wrapper>
                    <Wrapper>
                        <KategoriTabellBred>Slipp: </KategoriTabellBred>
                        <Opplysning>{friksjonsdataMetadata?.slipp}</Opplysning>
                    </Wrapper>
                    <Wrapper>
                        <KategoriTabellBred>Overvåkinsgrense: </KategoriTabellBred>
                        <Opplysning>{friksjonsdataMetadata?.overvåkingsgrense}</Opplysning>
                    </Wrapper>
                    <Wrapper>
                        <KategoriTabellBred>Formål: </KategoriTabellBred>
                        <Opplysning>{friksjonsdataMetadata?.formål}</Opplysning>
                    </Wrapper>
                    <Wrapper>
                        <KategoriTabellBred>StoppHp: </KategoriTabellBred>
                        <Opplysning>{friksjonsdataMetadata?.stoppHp}</Opplysning>
                    </Wrapper>
                    <Wrapper>
                        <KategoriTabellBred>Stopp: </KategoriTabellBred>
                        <Opplysning>{friksjonsdataMetadata?.stopp}</Opplysning>
                    </Wrapper>
                    <Wrapper>
                        <KategoriTabellBred>Utkjørt distanse: </KategoriTabellBred>
                        <Opplysning>{friksjonsdataMetadata?.utkjørtDistanse}</Opplysning>
                    </Wrapper>
                </StyledContainer>
            ) : (
                <StyledContainer>
                    <Wrapper>
                        <KategoriTabell>Dato: </KategoriTabell>
                        <Opplysning>
                            {friksjonsdataMetadata?.dato &&
                                tilNorskTimestamp(friksjonsdataMetadata.dato)}
                        </Opplysning>
                    </Wrapper>
                    <Wrapper>
                        <KategoriTabell>Operatør: </KategoriTabell>
                        <Opplysning>{friksjonsdataMetadata?.opratør}</Opplysning>
                    </Wrapper>
                    <Wrapper>
                        <KategoriTabell>Bilnummer: </KategoriTabell>
                        <Opplysning>{friksjonsdataMetadata?.bilnummer}</Opplysning>
                    </Wrapper>
                    <Wrapper>
                        <KategoriTabell>Veg: </KategoriTabell>
                        <Opplysning>{friksjonsdataMetadata?.vei}</Opplysning>
                    </Wrapper>
                    <Wrapper>
                        <KategoriTabell>Retning: </KategoriTabell>
                        <Opplysning>{friksjonsdataMetadata?.retning}</Opplysning>
                    </Wrapper>
                </StyledContainer>
            )}
            <VisSkjulKnapp onClick={() => setSeAllMetadata(!seAllMetadata)}>
                <Opplysning>{seAllMetadata ? "Skjul" : "Se alt"}</Opplysning>
            </VisSkjulKnapp>
        </>
    );
};

const StyledContainer = styled(Container)`
    padding: 24px 0 12px 0;
`;

const Wrapper = styled.div`
    display: flex;
    flex-direction: row;
    flex-wrap: wrap;
`;

interface KategoriTabellProps {
    harLangBredde?: boolean;
}
export const KategoriTabellBred = styled(Kategori)<KategoriTabellProps>`
    width: 200px;
`;
