import { Tekst } from "../../components/fellesKomponenter/typografi/Tekst";
import { Radioknapp } from "../../components/fellesKomponenter/radioknapper/Radioknapp";
import React from "react";
import { ColumnWrapperValg } from "./styled";
import { aktivGrafAtom, GrafType } from "../jotai/atoms";
import { useAtom } from "jotai";
import {
    GrafvalgLoggEvent,
    loggEventMedTabellnavnOgVerdi,
    TabellNavn,
} from "../../utils/loggFrontend";

export const AktivGrafValg = () => {
    const [aktivGraf, setAktivGraf] = useAtom(aktivGrafAtom);
    const håndterAktivGraf = (type: GrafType) => {
        setAktivGraf(type);
        loggEventMedTabellnavnOgVerdi(
            TabellNavn.grafvalg,
            GrafvalgLoggEvent.graftype,
            type.toString(),
        );
    };

    return (
        <ColumnWrapperValg>
            <Tekst bold={true} noMargin={true} størrelse={"M"}>
                Velg graftype
            </Tekst>
            <Radioknapp
                key={"aktivgrafHastighet"}
                value={GrafType.hastighet}
                checked={aktivGraf === GrafType.hastighet}
                name={"aktivgraf"}
                onChange={() => håndterAktivGraf(GrafType.hastighet)}
                størrelse={"S"}
                tekstStørrelse={"M"}
            >
                Hastighet
            </Radioknapp>
            <Radioknapp
                key={"aktivgrafDosering"}
                value={GrafType.dosering}
                checked={aktivGraf === GrafType.dosering}
                name={"aktivgraf"}
                onChange={() => håndterAktivGraf(GrafType.dosering)}
                størrelse={"S"}
                tekstStørrelse={"M"}
            >
                Dosering
            </Radioknapp>
        </ColumnWrapperValg>
    );
};
