import { GeneriskGraf } from "./GeneriskGraf";
import { Grafdata } from "./Grafer";
import { DoseringsValg } from "./DoseringsValg";
import { ReferanselinjeValg } from "./ReferanselinjeValg";
import { ValgContainer } from "./GeneriskGrafvalg";
import { Skillelinje } from "./styled";
import { AktivGrafValg } from "./AktivGrafValg";
import { DoseringsType, doseringsTypeAtom, grafdataDoseringAtom } from "../jotai/atoms";
import { useAtomValue } from "jotai";
import { hentTicksYaxisDosering } from "./grafUtils";

export const DoseringsGraf = ({ grafdata }: { grafdata: Grafdata[] }) => {
    const doseringsType = useAtomValue(doseringsTypeAtom);
    const tickArrayYaxis = hentTicksYaxisDosering(grafdata, doseringsType);

    return (
        <>
            <GeneriskGraf tickArrayYaxis={tickArrayYaxis}>
                <ValgContainer>
                    <AktivGrafValg />
                    <Skillelinje />
                    <DoseringsValg />
                    {doseringsType === DoseringsType.dosering && (
                        <>
                            <Skillelinje />
                            <ReferanselinjeValg grafdata={grafdata} />
                        </>
                    )}
                </ValgContainer>
            </GeneriskGraf>
        </>
    );
};
