import { Tekst } from "../../components/fellesKomponenter/typografi/Tekst";
import { Radioknapp } from "../../components/fellesKomponenter/radioknapper/Radioknapp";
import React from "react";
import { ColumnWrapperValg } from "./styled";
import { DoseringsType, doseringsTypeAtom } from "../jotai/atoms";
import { useAtom } from "jotai";
import {
    loggEventMedTabellnavnOgVerdi,
    TabellNavn,
    GrafvalgLoggEvent,
} from "../../utils/loggFrontend";

export const DoseringsValg = () => {
    const [doseringsType, setDoseringsType] = useAtom(doseringsTypeAtom);

    const håndterAktivGraf = (type: DoseringsType) => {
        setDoseringsType(type);
        loggEventMedTabellnavnOgVerdi(
            TabellNavn.grafvalg,
            GrafvalgLoggEvent.doseringstype,
            type.toString(),
        );
    };

    return (
        <ColumnWrapperValg>
            <Tekst bold={true} noMargin={true} størrelse={"M"}>
                Velg dosering eller sprederbredde
            </Tekst>
            <Radioknapp
                key={"doseringstype"}
                value={"doseringstype"}
                checked={doseringsType === DoseringsType.dosering}
                name={"doseringstype"}
                onChange={() => håndterAktivGraf(DoseringsType.dosering)}
                størrelse={"S"}
                tekstStørrelse={"M"}
            >
                Dosering
            </Radioknapp>
            <Radioknapp
                key={"sprederbreddetype"}
                value={"sprederbreddetype"}
                checked={doseringsType === DoseringsType.sprederbredde}
                name={"doseringstype"}
                onChange={() => håndterAktivGraf(DoseringsType.sprederbredde)}
                størrelse={"S"}
                tekstStørrelse={"M"}
            >
                Sprederbredde
            </Radioknapp>
        </ColumnWrapperValg>
    );
};
