import { ReferanselinjeValg } from "./ReferanselinjeValg";
import { GeneriskGraf } from "./GeneriskGraf";
import { ValgContainer } from "./GeneriskGrafvalg";
import { Skillelinje } from "./styled";
import { AktivGrafValg } from "./AktivGrafValg";
import { Grafdata } from "./Grafer";
import { hentTicksYaxisHastighet } from "./grafUtils";
import { Tekst } from "../../components/fellesKomponenter/typografi/Tekst";
import styled from "styled-components";

interface HastighetsGrafProps {
    grafdata: Grafdata[];
    visDosering: boolean;
}
export const HastighetsGraf = ({ grafdata, visDosering }: HastighetsGrafProps) => {
    const tickArrayYaxis = hentTicksYaxisHastighet(grafdata);

    return (
        <>
            <GeneriskGraf tickArrayYaxis={tickArrayYaxis}>
                <ValgContainer>
                    {visDosering && (
                        <>
                            <AktivGrafValg />
                            <Skillelinje />
                        </>
                    )}
                    <ReferanselinjeValg grafdata={grafdata} />
                </ValgContainer>
                <InfotekstWrapper>
                    <Tekst noMargin={true} størrelse={"M"} bold={true}>
                        Hvordan regnes farten ut?
                    </Tekst>
                    <Tekst størrelse={"M"} noMargin={true}>
                        Når entreprenørene sender inn data fra bilene så er produksjonen knyttet til
                        GPS-punkter. ELRAPP knytter disse punktene til veglenker sånn at man skal
                        kunne se hvor de har kjørt på veien (avkjørsler, filer etc). Disse
                        veglenkene viser vi igjen i kartet. Veglenker har ulik lengde, noen er korte
                        og noen er lange (det ser du i kartet når du holder musen over produksjon
                        uten å trykke på det, noen er lange og noen er korte). GPS-punktene fra
                        entreprenørene kommer med jevne mellomrom (hver 100 m). Farten som sendes
                        inn fra bilene er hastigheten bilen har på det GPS-punktet som dataen er
                        registrert på. Siden GPS-punktene blir gjort om til veglenker så lager vi en
                        snitthastighet på denne måten:
                    </Tekst>
                    <Tekst størrelse={"M"} noMargin={false}>
                        <i>
                            For ett kjøretøy på én økt som gjør samme aktivitet og/eller legger
                            samme materiale innenfor samme veglenke og innenfor maks ett minutt -
                            slår vi sammen punkthastighetene som har kommet inn og regner ut
                            snittet.
                        </i>
                    </Tekst>
                </InfotekstWrapper>
            </GeneriskGraf>
        </>
    );
};

const InfotekstWrapper = styled.div`
    display: flex;
    flex-direction: column;
    padding: 10px;
    margin-top: 20px;
`;
